import { Deserialize, Deserializer, IterableAccess, MapAccess, Visitor } from './interface';
export declare class GenericSeed<T> implements Deserialize<T> {
    static deserialize<T, D extends Deserializer>(deserializer: D): T;
    deserialize<D extends Deserializer>(deserializer: D): T;
}
export declare class GenericVisitor<T> implements Visitor<T> {
    visitString(value: string): T;
    visitNumber(value: number): T;
    visitBigInt(value: bigint): T;
    visitBoolean(value: boolean): T;
    visitSymbol(value: symbol): T;
    visitNull(): T;
    visitObject(access: MapAccess): T;
    visitIterable(access: IterableAccess): T;
}
